=== debian/changelog ===
sipp (3.3-1parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:11:50 +0200

sipp (3.3-1kali5) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Sophie Brun ]
  * Use unversioned libncurses-dev
  * Remove dookie from Uploaders

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 12 Jul 2023 14:24:07 +0200

sipp (3.3-1kali4) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Trim trailing whitespace
  * Update standards version to 4.6.1, no changes needed.
  * Use secure URI in Homepage field.
  [ Ben Wilson ]
  * Add Uploaders
  * Remove template comment and switch spaces to tabs
  [ Steev Klimaszewski ]
  * Add d/watch pointing to the github repo
  * Add lintian override
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Fri, 13 Jan 2023 00:50:18 -0600

sipp (3.3-1kali3) kali-dev; urgency=medium

  [ Raphaël Hertzog ]
  * Update Maintainer field
  * Update Vcs-* fields for the move to gitlab.com
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file

  [ Sophie Brun ]
  * Update packaging

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 13 Jan 2021 14:59:27 +0100

sipp (3.3-1kali2) kali-dev; urgency=medium

  * Updated usage examples (Closes: 0004177)

 -- Devon Kearns <dookie@kali.org>  Wed, 23 Aug 2017 14:46:40 -0600

sipp (3.3-1kali1) kali; urgency=low

  * Fixed build and install depends

 -- Devon Kearns <dookie@kali.org>  Sat, 29 Dec 2012 07:08:10 -0700

sipp (3.3-1kali0) kali; urgency=low

  * Initial release

 -- Devon Kearns <dookie@kali.org>  Sat, 29 Dec 2012 06:48:41 -0700
