=== debian/control ===
Source: sipp
Section: utils
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: debhelper-compat (= 13), libpcap-dev, libncurses-dev
Standards-Version: 4.6.2
Homepage: https://sipp.sourceforge.net/

Package: sipp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcap0.8
Description: Traffic generator for the SIP protocol
 SIPp is a free Open Source test tool / traffic generator
 for the SIP protocol. It includes a few basic SipStone user
 agent scenarios (UAC and UAS) and establishes and releases
 multiple calls with the INVITE and BYE methods. It can also
 reads custom XML scenario files describing from very simple
 to complex call flows. It features the dynamic display of
 statistics about running tests (call rate, round trip delay,
 and message statistics), periodic CSV statistics dumps, TCP
 and UDP over multiple sockets or multiplexed with
 retransmission management and dynamically adjustable call
 rates.
