=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_configure:

override_dh_auto_install:
	dh_installdirs
	install sipp $(CURDIR)/debian/sipp/usr/bin/
